/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: core_insn.h 619 2014-03-18 06:10:27Z nmir-saito $
 */


/*
 *   ¸ü̿Υ饤ؿARMѡ
 */

#ifndef CORE_INSN_H
#define CORE_INSN_H

#include "arm.h"

/*
 *  ꤬ѹ뤳Ȥ򥳥ѥ뤿Υޥ
 */
#define ARM_MEMORY_CHANGED Asm("":::"memory")

/*
 *  쥸ؿ
 */

#ifndef __thumb__

/*
 *  ơ쥸CPSRˤθͤɽФ
 */
Inline uint32_t
current_sr(void)
{
	uint32_t sr;
	Asm("mrs  %0,CPSR" : "=r"(sr));
	return(sr);
}

/*
 *  ơ쥸CPSRˤθͤѹ
 */
Inline void
set_sr(uint32_t sr)
{
	Asm("msr CPSR, %0" : : "r"(sr) : "cc");
}

#else /* __thumb__ */

/*
 * Thumb Mode Ǥϡmrs/msrѤǤʤᡤؿȤơ
 * ARM Mode ѹƼ¹Ԥ롥 
 *  
 */

/*
 *  ơ쥸CPSRˤθͤɽФ
 */
extern uint32_t current_sr(void);

/*
 *  ơ쥸CPSRˤθͤѹ
 */
extern void set_sr(uint32_t sr);

#endif /* __thumb__ */
#endif /* CORE_INSN_H */
